//+------------------------------------------------------------------+
//|                               Ehlers distance coefficient filter |
//+------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue

//
//
//
//
//

extern int  Length              = 20;
extern int  Price               = PRICE_CLOSE;
extern bool OriginalCalculation = true;

//
//
//
//
//

double filter[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init() { SetIndexBuffer(0,filter); return(0); }
int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
   
   for(i=limit; i>=0; i--) filter[i] = iEhlers(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,0,i);
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  enlf.work[][2];
#define enlf.price  0
#define enlf.smooth 1

//
//
//
//
//

double  iEhlers(double price,int length, int forBuffer, int i)
{   
   if (ArrayRange(enlf.work,0)!=Bars) ArrayResize(enlf.work,Bars);
   
   int r = Bars-i-1;
   int s = forBuffer*2;

   //
   //
   //
   //
   //
      
      enlf.work[r][s+enlf.price]  = price;
      if (OriginalCalculation)
            enlf.work[r][s+enlf.smooth] = enlf.work[r][s+enlf.price];
      else  enlf.work[r][s+enlf.smooth] = (enlf.work[r][s+enlf.price]+2.0*enlf.work[r-1][s+enlf.price]+2.0*enlf.work[r-2][s+enlf.price]+enlf.work[r-3][s+enlf.price])/6.0;

      //
      //
      //
      //
      //
      
      double sumCoef = 0;
      double num     = 0;
      for (int k=0; k<length; k++)
      {
         double distance = 0;
         for (int j=1; j<length; j++)
            distance += MathPow(enlf.work[r-k][s+enlf.smooth]-enlf.work[r-k-j][s+enlf.smooth],2);
            sumCoef  += distance;
            num      += distance*enlf.work[r-k][s+enlf.smooth];
      } 
      
      if (sumCoef !=0)
            return(num/sumCoef);
      else  return(0);       
}